#ifndef IZ_APP_H
#define IZ_APP_H

#include <SDL.h>
#include <libwebsockets.h>
#include "memory/IZ_pool.h"
#include "input/IZ_app.h"
#include "net/IZ_app.h"
#include "output/video/IZ_app.h"

typedef enum {
	IZ_APP_RUN_RESULT_OK,
	IZ_APP_RUN_SDL_INIT_ERROR,
	IZ_APP_RUN_VIDEO_INIT_ERROR,
	IZ_APP_RUN_INPUT_INIT_ERROR,
	IZ_APP_RUN_POOL_INIT_ERROR,
	IZ_APP_RUN_NETWORKING_ERROR,
} IZ_AppRunResult;

typedef struct IZ_App {
	IZ_InputState input_state;
	IZ_VideoState video_state;
	IZ_Pool pool;

	u64 ticks;
	IZ_NetState net_state;
} IZ_App;

IZ_ProcedureResult IZ_AppRun(struct IZ_App*, u8, const char**);

IZ_ProcedureResult IZ_AppConnect(void*);

#endif
