#ifndef IZ_NET_H
#define IZ_NET_H

#include <minIni.h>
#include "../IZ_common.h"
#include "../IZ_config.h"
#include "core/IZ_websocket.h"

#define IZ_DEFAULT_MOTD ""


typedef struct {
	u16 port;
	char name[64];
	char motd[128];
} IZ_NetConfig;

typedef struct {
	IZ_NetConfig config;
	IZ_Websocket ws;
} IZ_NetState;

static IZ_NetState IZ_NET_DEFAULT_STATE = {
	.config = {
		.port = 42069,
		.name = IZ_APP_NAME " Server",
		.motd = IZ_DEFAULT_MOTD,
	},
	.ws = {
		.interrupted = false,
		.context = NULL,
		.connection = NULL,
		.user_data = NULL,
	},
};

IZ_ProcedureResult IZ_NetInitialize(IZ_NetState*, void*, const char*, u8, const char**);

IZ_ProcedureResult IZ_NetSaveConfig(IZ_NetState*, const char*);

#endif
